// kiwiDlg.h : header file
//

#if !defined(AFX_KIWIDLG_H__EF6CC5B1_7EB6_4824_BC1E_B1BE55D29E5A__INCLUDED_)
#define AFX_KIWIDLG_H__EF6CC5B1_7EB6_4824_BC1E_B1BE55D29E5A__INCLUDED_

#pragma warning(disable:4786)

//Byron add in
#include <fstream> //for read data
#include <vector>  //for store data in vector
#include <algorithm> //for sort data
#include <set>
#include <functional>

#include <stdio.h> //for time
#include <stdlib.h> //for time
#include <time.h> //for time
#include <math.h>

using namespace std;

typedef vector<short> SROW; //-32767 to 32767, can be used to dimension ids, enough, so # of columns is limited to 32767
typedef vector<SROW> SSQUARE;

typedef vector<unsigned short> UROW; //0 - 65535, used for rows and indexes, so # of rows is limited to 65535
typedef vector<UROW> USQUARE;  //for candidatesSupports and patternsSupports
typedef vector<USQUARE> UCUBE;

typedef vector<unsigned long> LROW; //0 - 4294967295. Using 4 bypes, same as int
typedef vector<LROW> LSQUARE; //not used in this version "kiwi.exe"
typedef vector<LSQUARE> LCUBE;//not used in this version "kiwi.exe"

typedef pair <unsigned short, unsigned long> ULPAIR;
typedef pair <unsigned long, unsigned long> LLPAIR;

typedef set<unsigned short> USET; 
typedef set<unsigned long> LSET; //not used in this version "kiwi.exe"

//end of Byron add in

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CKiwiDlg dialog

class CKiwiDlg : public CDialog
{
// Construction
public:

	CString toStringROW2(SROW v);
	CString toStringROW2(UROW v);
	CString toStringROW2(LROW v);
	CString toStringAllClusters();
	bool subSequence (SROW sub, int sup);
	bool subSequence (SROW sub, SROW sup);
	bool subSequence (UROW sub, UROW sup);
	void extend(SROW &pattern, UROW cluster);//kiwi2, changed UROW to LROW
	SROW LCS(SROW str1, SROW str2);
	bool subPattern(int li, int ri, int lj, int rj);
	CString toStringSQUARE(USQUARE s);
	CString toStringSQUARE(SSQUARE s);
	CString toStringSQUARE(LSQUARE s);
	CString toStringROW(UROW v);
	CString toStringROW(LROW v);
	CString toStringROW(SROW v);
	CString toStringClusters();
	bool subSequence(int p, int s);
	CString toStringAllPatterns();
	void writeFile(CString FileName, CString toWrite);
	vector <CString> columns; //storing the names of the columns
	vector <CString> rows; //storing the names of the rows
	SSQUARE seqs; //storing all the sequences
	SSQUARE indexes; //storing indexes of columns for sequences
	LCUBE allPatterns; //storing patterns for all levels
	vector < ULPAIR > queries; //for each pair, first is level, second is row index, used for initially quering patterns
	SSQUARE queryPatterns; //stores real patterns after scanning the database, corresponding to queryClusters
	USQUARE queryClusters; // have the same size as queryPatterns. each row contains ids for rows supporting the pattern in queryPatterns with the same index	//kiwi2, change to LSQUARE

	SSQUARE chosenPatterns; //chosen for writing or show
	USQUARE chosenClusters; //chosen for writing or show //kiwi2, change to LSQUARE

	CKiwiDlg(CWnd* pParent = NULL);	//standard constructor
    vector <int> mark; //mark the clusters that have exactly the same row members as one of the previous clusters in the list
	
	// Dialog Data
	//{{AFX_DATA(CKiwiDlg)
	enum { IDD = IDD_KIWI_DIALOG };
	CSpinButtonCtrl	m_spinSubset;
	int		m_cols; //# of columns
	CString	m_dataSource; //from where to read in the data file
	int		m_rows; //# of rows
	CString	m_writeToDir; //to which directory to write data file, if blank, current. can be c: or h: or c:\temp\ etc;
	float	m_readDataTime;
	CString	m_show;
	int		m_k;
	int		m_w;
	float	m_clusteringTime;
	int		m_min_row;
	int		m_noise;
	int		m_seqLength;
	int		m_queryMinCol;
	int		m_queryTopK;
	int		m_queryLevelHigh;
	int		m_queryLevelLow;
	int		m_queryMinSupport;
	int		m_queryRowIndexHigh;
	int		m_sizeOfQueryPatterns;
	int		m_queryRowIndexLow;
	int		m_queryLevel;
	int		m_queryRowIndex;
	float	m_scanTime;
	BOOL	m_actual;
	CString	m_patternSource;
	BOOL	m_closed;
	BOOL	m_removeMarked;
	int		m_numberOfClusters;
	BOOL	m_timestampInFileName;
	float	m_queryTime;
	int		m_memory;
	int		m_subset;
	int		m_kplus;
	int		m_deficit;
	int		m_levels;
	int		m_support;
	double	m_probability;
	int		m_seq1;
	int		m_seq2;
	int		m_longestLength;
	float	m_LCStime;
	float	m_autoTime;
	BOOL	m_extend;
	int		m_dimensionalityHigh;
	int		m_dimensionalityLow;
	int		m_clusterSizeHigh;
	int		m_clusterSizeLow;
	int		m_numberOfMarked;
	BOOL	m_useLCS;
	CString	m_clusterSource;
	BOOL	m_howToShowPatterns;
	BOOL	m_markRepeats;
	int		m_seq;
	int		m_seqLengthThreshold;
	int		m_numberOfRemoved;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CKiwiDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CKiwiDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnReadData();
	afx_msg void OnClear();
	afx_msg void OnShowSeqs();
	afx_msg void OnShowColumns();
	afx_msg void OnShowRows();
	afx_msg void OnShowIndexes();
	afx_msg void OnClustering();
	afx_msg void OnPreprocessing();
	afx_msg void OnReadPattern();
	afx_msg void OnQueryGetPatterns();
	afx_msg void OnQueryShowPatterns();
	afx_msg void OnQueryGetClusters();
	afx_msg void OnShowClusters();
	afx_msg void OnWriteClusters();
	afx_msg void OnHelp();
	afx_msg void OncalculateProbability();
	afx_msg void Ondoubling();
	afx_msg void OnLCS();
	afx_msg void OnLCSAll();
	afx_msg void OnAuto();
	afx_msg void OnChooseClusters();
	afx_msg void OnReadClusters();
	afx_msg void OnShrinkClu();
	afx_msg void OnWriteClusters2();
	afx_msg void OnWriteActualClusters();
	afx_msg void OnClustering2();
	afx_msg void OnShowAllPatterns();
	afx_msg void Onabout();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_KIWIDLG_H__EF6CC5B1_7EB6_4824_BC1E_B1BE55D29E5A__INCLUDED_)
